// Watch.cpp : Implementation of CWatch
#include "stdafx.h"
#include "FileMonitor.h"
#include "Watch.h"

#include <algorithm>
/////////////////////////////////////////////////////////////////////////////
// CWatch

DWORD WINAPI ThreadFunc(LPVOID lpParam);

STDMETHODIMP CWatch::AddPath(BSTR sPathName)
{
	// TODO: Add your implementation code here
	USES_CONVERSION;
	if ( sPathName )
	{
		deqString::iterator it = std::find(m_Paths.begin(), m_Paths.end(), OLE2T(sPathName));
		if ( it == m_Paths.end() )
		{
			bool bWatching = m_bStarted;
			m_Paths.push_back(OLE2T(sPathName));
			if ( bWatching )
			{
				cstring sPath = OLE2T(sPathName);
				ATLTRACE("RemovePath %s\n", sPath.c_str());
				SetEvent(m_hRefreshEvent);
			}
		}
	}
	return S_OK;
}

STDMETHODIMP CWatch::get_Start(VARIANT_BOOL *pVal)
{
	// TODO: Add your implementation code here

	*pVal = ( m_bStarted ) ? VARIANT_TRUE : VARIANT_FALSE;
	return S_OK;
}

STDMETHODIMP CWatch::put_Start(VARIANT_BOOL newVal)
{
	// TODO: Add your implementation code here

	if ( newVal == VARIANT_TRUE )	// Start the Watch
		start();
	else	// Stop the Watch
		stop();
	return S_OK;
}

STDMETHODIMP CWatch::RemovePath(BSTR sPathName)
{
	// TODO: Add your implementation code here
	USES_CONVERSION;
	deqString::iterator it = std::find(m_Paths.begin(), m_Paths.end(), OLE2T(sPathName));
	if ( it != m_Paths.end() )
	{
		bool bWatching = m_bStarted;
		m_Paths.erase(it);
		if ( bWatching )
		{
			cstring sPath = OLE2T(sPathName);
			ATLTRACE("RemovePath %s\n", sPath.c_str());
			SetEvent(m_hRefreshEvent);
		}
	}

	return S_OK;
}

void CWatch::start()
{
	if ( ! m_bStarted )
	{
		DWORD dwThreadId;
		m_hThread = CreateThread(NULL, 0, ThreadFunc, (LPVOID) this, 0, &dwThreadId);
		ATLTRACE("My thread : %x\n", dwThreadId);
		if ( m_hThread == NULL )
			return;
		m_bStarted = true;
	}
}

void CWatch::stop()
{
	if ( m_bStarted )
	{
		if ( m_hEvent != NULL )
		{
			SetEvent(m_hEvent);
			if ( m_hThread != NULL )
			{
				CloseHandle(m_hThread);
				m_hThread = NULL;
			}
			m_bStarted = false;
		}
	}
}

DWORD WINAPI ThreadFunc(LPVOID lpParam)
{
	const int FileHandleStartIndex = 2;
	CWatch *pWatch = (CWatch *) lpParam;
	LPVOID lpvBase = NULL;
	HANDLE *hHandles = NULL;
	int nHandles = 0;
	int i = 0;

	while(1) // Endless loop
	{
		int size = sizeof(HANDLE) * (pWatch->m_Paths.size() * 3 + FileHandleStartIndex);
		if ( lpvBase == NULL )
		{
			lpvBase = VirtualAlloc(NULL, size, MEM_COMMIT, PAGE_READWRITE);
			hHandles = (HANDLE *) lpvBase;
			nHandles = 0;
			i = FileHandleStartIndex;

			hHandles[0] = pWatch->m_hEvent;
			hHandles[1] = pWatch->m_hRefreshEvent;
			nHandles = FileHandleStartIndex;
			for(deqString::iterator it = pWatch->m_Paths.begin(); it != pWatch->m_Paths.end(); it++)
			{
				HANDLE hHandle = FindFirstChangeNotification((LPCTSTR) (*it).c_str(), FALSE, 
															FILE_NOTIFY_CHANGE_LAST_WRITE);
				if ( hHandle != INVALID_HANDLE_VALUE )
				{
					hHandles[i] = hHandle;
					nHandles++;

					hHandle = FindFirstChangeNotification((LPCTSTR) (*it).c_str(), FALSE, 
															      FILE_NOTIFY_CHANGE_FILE_NAME);
					if ( hHandle != INVALID_HANDLE_VALUE )
					{
						hHandles[i + 1] = hHandle;
						nHandles++;

						hHandle = FindFirstChangeNotification((LPCTSTR) (*it).c_str(), FALSE,
																FILE_NOTIFY_CHANGE_DIR_NAME);
						if ( hHandle != INVALID_HANDLE_VALUE )
						{
							hHandles[i + 2] = hHandle;
							i += 3;
							nHandles++;
						}
						else
						{
							FindCloseChangeNotification(hHandles[i]);
							FindCloseChangeNotification(hHandles[i + 1]);
						}
					}
					else
						FindCloseChangeNotification(hHandles[i]);
				}
			}
		}

		DWORD dwResult = WaitForMultipleObjects(nHandles, hHandles, FALSE, INFINITE);
		if ( dwResult != WAIT_FAILED )
		{
			i = dwResult - ( WAIT_OBJECT_0 + 1);
			if ( i > 0 )
			{
				int nType = i % 3;
				if ( nType == 0 )
					nType = 3;
				int nPath = (i-1) / 3;
				if ( nPath >= 0 )
				{
					pWatch->m_sNotify = pWatch->m_Paths[nPath];
					pWatch->PostMessage(WM_WATCH_NOTIFY, nType, 0);
				}
			}
		}


		if (    dwResult == WAIT_OBJECT_0 
			 || dwResult == WAIT_OBJECT_0 + 1 
			 || dwResult == WAIT_FAILED )
		{
			for(i = FileHandleStartIndex; i < nHandles; i++)
				FindCloseChangeNotification(hHandles[i]);
			VirtualFree(lpvBase, size, MEM_DECOMMIT);
			lpvBase = NULL;
		}
		else
			FindNextChangeNotification(hHandles[dwResult]);

		if ( dwResult == WAIT_OBJECT_0 )
		{
			break;
		}
	}

	return 0;
}
